/**
 * ***************************************************************
 * JADE - Java Agent DEvelopment Framework is a framework to develop
 * multi-agent systems in compliance with the FIPA specifications.
 * Copyright (C) 2000 CSELT S.p.A.
 * 
 * GNU Lesser General Public License
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation,
 * version 2.1 of the License.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 * **************************************************************
 */
package jade.content.lang.sl;

/**
 * @author Giovanni Caire - TILAB
 */
public interface SL2Vocabulary extends SL1Vocabulary {
  public static final String         IOTA = "iota";
  public static final String         ANY = "any";
  public static final String         ALL = "all";
  
  public static final String         EXISTS = "exists";
  public static final String         EXISTS_WHAT = "what";
  public static final String         EXISTS_CONDITION = "condition";
  
  public static final String         FORALL = "forall";
  public static final String         FORALL_WHAT = "what";
  public static final String         FORALL_CONDITION = "condition";
  
  public static final String         BELIEF = "B";
  public static final String         BELIEF_AGENT = "agent";
  public static final String         BELIEF_CONDITION = "condition";
  
  public static final String         UNCERTAINTY = "U";
  public static final String         UNCERTAINTY_AGENT = "agent";
  public static final String         UNCERTAINTY_CONDITION = "condition";
  
  public static final String         PERSISTENT_GOAL = "PG";
  public static final String         PERSISTENT_GOAL_AGENT = "agent";
  public static final String         PERSISTENT_GOAL_CONDITION = "condition";
  
  public static final String         INTENTION = "I";
  public static final String         INTENTION_AGENT = "agent";
  public static final String         INTENTION_CONDITION = "condition";
  
  public static final String         FEASIBLE = "feasible";
  public static final String         FEASIBLE_ACTION = "action";
  public static final String         FEASIBLE_CONDITION = "condition";
  
  public static final String         ACTION_SEQUENCE = ";";
  public static final String         ACTION_SEQUENCE_FIRST = "first";
  public static final String         ACTION_SEQUENCE_SECOND = "second";
  
  public static final String         ACTION_ALTERNATIVE = "|";
  public static final String         ACTION_ALTERNATIVE_FIRST = "first";
  public static final String         ACTION_ALTERNATIVE_SECOND = "second";
}
